/*
 * Created on 19.05.2008
 */
package ssadchaz;

public class Eigenschaftsprobe extends Skript{
	
	String eigenschaft;
	String mod;
	int gelungen;
	int misslungen;
	
	public Eigenschaftsprobe(String []param){
		this.name = param[0].trim();
		this.eigenschaft = param[1].trim();
		this.mod = param[2].trim();
		this.gelungen = Integer.parseInt(param[3].trim());
		this.misslungen = Integer.parseInt(param[4].trim());
	}
	
	public String toString(){
		return "Eigenschaftsprobe: wenn "+eigenschaft+" "+(mod.startsWith("-")?mod:"+"+mod)+" bestanden, dann ["+gelungen+"], ansonsten ["+misslungen+"]";
	}

	public String gibSkript(){
		String probe = System.getProperty("line.separator") +
	      			   "var mod = " + Abenteuer.wandleTop(this.mod) + ";" + System.getProperty("line.separator") +
	      			   System.getProperty("line.separator") +
	      			   "function PROBE(){" + System.getProperty("line.separator") + 
	      			   "   if(top.werte == 1){" + System.getProperty("line.separator") +
	      			   "      var taw = top."+Abenteuer.wandleString(this.eigenschaft)+" - mod;" + System.getProperty("line.separator") +
	      			   "      if(mod < 0){" + System.getProperty("line.separator") +
	      			   "         var t = document.createTextNode('"+this.eigenschaft+"' + ' (erleichtert um ' + Math.abs(mod) + '): ' + (taw));" + System.getProperty("line.separator") +
	      			   "      }else if(mod > 0){" + System.getProperty("line.separator") +
	      			   "         var t = document.createTextNode('"+this.eigenschaft+"' + ' (erschwert um ' + mod + '): ' + (taw));" + System.getProperty("line.separator") +
	      			   "      }else {" + System.getProperty("line.separator") +
	      			   "         var t = document.createTextNode('"+this.eigenschaft+": ' + taw);" + System.getProperty("line.separator") +
	      			   "      }" + System.getProperty("line.separator") +	      			   
	      			   "      document.getElementById('m').appendChild(t);" + System.getProperty("line.separator") +
	      			   "   }" + System.getProperty("line.separator") + 
	      			   "}" + System.getProperty("line.separator");

		String wuerfel = System.getProperty("line.separator") + 
        	           "function wuerfel(){" + System.getProperty("line.separator") +
        	           "   var w1 = Math.ceil((Math.random()*100)%20);" + System.getProperty("line.separator") +
        	           "   document.getElementById('w1').appendChild(document.createTextNode(w1));" + System.getProperty("line.separator") +
        	           System.getProperty("line.separator") +
        	           "   if(top.werte == 1){" + System.getProperty("line.separator") +
        	           "      var link = document.createElement('a');" + System.getProperty("line.separator") +
        	           "      var href = document.createAttribute('href');" + System.getProperty("line.separator") +
        	           "      link.setAttributeNode(href);" + System.getProperty("line.separator") +
        	           System.getProperty("line.separator") +
        	           "      var taw = top."+Abenteuer.wandleString(this.eigenschaft)+" - mod - w1;" + System.getProperty("line.separator") +
        	           System.getProperty("line.separator") +
        	           "      if(taw >= 0){" + System.getProperty("line.separator") +
        	           "         href.nodeValue = '"+Abenteuer.fuelleDreistellig(this.gelungen)+".html';" + System.getProperty("line.separator") +
        	           "         link.appendChild(document.createTextNode('Gelungen. ["+this.gelungen+"]'));" + System.getProperty("line.separator") +
        	           "      }else{" + System.getProperty("line.separator") +
        	           "         href.nodeValue = '"+Abenteuer.fuelleDreistellig(this.misslungen)+".html';" + System.getProperty("line.separator") +
        	           "         link.appendChild(document.createTextNode('Misslungen. ["+this.misslungen+"]'));" + System.getProperty("line.separator") +
        	           "      }" + System.getProperty("line.separator") +
        	           "      for(var i = document.getElementById('links').childNodes.length; i != 0; i--){" + System.getProperty("line.separator") +
        	           "         document.getElementById('links').removeChild(document.getElementById('links').firstChild);" + System.getProperty("line.separator") +
        	           "      }" + System.getProperty("line.separator") +
        	           "      document.getElementById('links').appendChild(link);" + System.getProperty("line.separator") +
        	           "   }" + System.getProperty("line.separator") +
        	           "   document.F.button.disabled = true;" + System.getProperty("line.separator") +
        	           "}";

		String text = probe + wuerfel;
		return text;	
	}
}
