/*
 * Created on 16.01.2007
 */
package ssadchaz;

public class Abschnitt {
	int nr;
	String bez;
	boolean da;
	boolean gebraucht;
	String start;
	String text;
	String bausteine;
	Abschnitt[] vorgaenger;
	
	//Nachfolgerabschnitte mit den Texten in "links" und ob es an eine Bedingung geknpft ist
	Abschnitt[] nachfolger;
	String[] links;
	boolean[] bedingung;
	Skript skripte;
	
	public Abschnitt(int nr){
		this.nr = nr;
	}
	
	public Abschnitt(int nr, String text, Abschnitt[] vorgaenger, Abschnitt[] nachfolger){
		this.nr = nr;
		this.da = false;
		this.gebraucht = false;
		this.text = text;
		this.vorgaenger = vorgaenger;
		this.nachfolger = nachfolger;
	}
	
	public Abschnitt(String s){
		this.nr = -1;
		this.bez = s;
	}
	
	public void setzeSkript(Skript s){
		if(skripte == null){
			skripte = s;
		}else{
			Skript akt = skripte;
			for(;akt.f != null; akt = akt.f);
			akt.f = s;
		}
	}
	
	public void setzeNachfolger(Abschnitt a, String t, boolean b){
		a.gebraucht = true;
		a.setzeVorgaenger(this);
		if(nachfolger == null){
			nachfolger = new Abschnitt[1];
			links = new String[1];
			bedingung = new boolean[1];
			nachfolger[0] = a;
			links[0] = t;
			bedingung[0] = b;
		}else{
			Abschnitt[] neuA = new Abschnitt[nachfolger.length+1];
			String[] neuS = new String[links.length+1];
			boolean[] neuB = new boolean[bedingung.length+1];
			for(int i = 0; i < nachfolger.length; i++){
				neuA[i] = nachfolger[i];
				neuS[i] = links[i];
				neuB[i] = bedingung[i];
			}
			neuA[neuA.length-1] = a;
			neuS[neuS.length-1] = t;
			neuB[neuB.length-1] = b;
			nachfolger = neuA;
			links = neuS;
			bedingung = neuB;
		}
	}
	
	public void setzeNachfolger(String href, String t, boolean b){
		Abschnitt a = new Abschnitt(href);
		a.gebraucht = true;
		a.setzeVorgaenger(this);
		if(nachfolger == null){
			nachfolger = new Abschnitt[1];
			links = new String[1];
			bedingung = new boolean[1];
			nachfolger[0] = a;
			links[0] = t;
			bedingung[0] = b;
		}else{
			Abschnitt[] neuA = new Abschnitt[nachfolger.length+1];
			String[] neuS = new String[links.length+1];
			boolean[] neuB = new boolean[bedingung.length+1];
			for(int i = 0; i < nachfolger.length; i++){
				neuA[i] = nachfolger[i];
				neuS[i] = links[i];
				neuB[i] = bedingung[i];
			}
			neuA[neuA.length-1] = a;
			neuS[neuS.length-1] = t;
			neuB[neuB.length-1] = b;
			nachfolger = neuA;
			links = neuS;
			bedingung = neuB;
		}
	}
	
	public void setzeVorgaenger(Abschnitt a){
		if(vorgaenger == null){
			vorgaenger = new Abschnitt[1];
			vorgaenger[0] = a;
		}else{
			Abschnitt[] neu = new Abschnitt[vorgaenger.length+1];
			for(int i = 0; i < vorgaenger.length; i++){
				neu[i] = vorgaenger[i];
			}
			neu[neu.length-1] = a;
			vorgaenger = neu;
		}
	}
}
