/*
 * Created on 04.01.2008
 */
package ssadchaz;

public class Kampf extends Skript{
	
	String AT;
	String PA;
	int wuerfelTP;
	int modTP;
	String LE;
	String maxLE;
	String minLE;
	String RS;
	boolean gegnerbeginnt;
	boolean ergeben;
	boolean unbewaffnet;
	int finte;
	int wuchtschlag;
	int sieg;
	String textSieg;
	int niederlage;
	String textNiederlage;
	String textErgeben = "Ich ergebe mich.";
	
	public Kampf(String []param){
		this.name = param[0];
		this.AT = param[1];
		this.PA = param[2];
		this.wuerfelTP = wandleZahl(param[3]);
		this.modTP = wandleZahl(param[4]);
		this.LE = param[5];
		this.maxLE = param[6];
		this.minLE = param[7];
		this.RS = param[8];
		if(wandleZahl(param[9]) == 0)
			this.gegnerbeginnt = true;
		else
			this.gegnerbeginnt = false;
		if(param[10].equals("ja"))
			this.ergeben = true;
		else
			this.ergeben = false;
		if(param[11].equals("ja"))
			this.unbewaffnet = false;
		else
			this.unbewaffnet = true;
		this.finte = wandleZahl(param[12]);
		this.wuchtschlag = wandleZahl(param[13]);
		this.sieg = wandleZahl(param[14]);
		this.textSieg = param[15];
		this.niederlage = wandleZahl(param[16]);
		this.textNiederlage = param[17];
	}
	
	public String toString(){
		return "Kampf: wenn gewonnen, dann ["+sieg+"], ansonsten ["+niederlage+"]";
	}

	public String gibSkript(){
		String kampf = System.getProperty("line.separator") +
		  "function KAMPF(){" + System.getProperty("line.separator") +
		  "   document.getElementById('name').appendChild(document.createTextNode(top.vorname));" + System.getProperty("line.separator") +
		  "   setzeLink('"+Abenteuer.fuelleDreistellig(this.niederlage)+".html', '"+(this.ergeben?this.textErgeben+" ["+this.niederlage+"]":"")+"');" + System.getProperty("line.separator") +
		  "}" + System.getProperty("line.separator");

		String wuerfel = System.getProperty("line.separator") +					  
	      "var gegnerAT = " + Abenteuer.wandleTop(Abenteuer.wandleString(this.AT)) + ";" + System.getProperty("line.separator") +
	      "var gegnerPA = " + Abenteuer.wandleTop(Abenteuer.wandleString(this.PA)) + ";" + System.getProperty("line.separator") +
	      "var gegnerWuerfelTP = " + Abenteuer.wandleTop(this.wuerfelTP) + ";" + System.getProperty("line.separator") +
	      "var gegnerZusatzTP = " + Abenteuer.wandleTop(this.modTP) + ";" + System.getProperty("line.separator") +
	      "var gegnerLE = " + Abenteuer.wandleTop(Abenteuer.wandleString(this.LE)) + ";" + System.getProperty("line.separator") +
	      "var gegnerLEmax = " + Abenteuer.wandleTop(Abenteuer.wandleString(this.maxLE)) + ";" + System.getProperty("line.separator") + 
	      "var gegnerLEmin = " + Abenteuer.wandleTop(Abenteuer.wandleString(this.minLE)) + ";" + System.getProperty("line.separator") +
	      "var gegnerRS = " + Abenteuer.wandleTop(Abenteuer.wandleString(this.RS)) + ";" + System.getProperty("line.separator") +
	      "var gegnerUnbewaffnet = " + (this.unbewaffnet?1:0) + ";" + System.getProperty("line.separator") +
	      System.getProperty("line.separator") +
	      "var finte = 0;" + System.getProperty("line.separator") +
	      "var wuchtschlag = 0;" + System.getProperty("line.separator") +
	      "var erschwert = 0;" + System.getProperty("line.separator") +
	      "var plus = 0;" + System.getProperty("line.separator") +
	      System.getProperty("line.separator") +
	      "//0 = Attacke, 1 = Parade, 2 = Gegner pariert, 3 = Held pariert, 4 = Trefferpunkte, 5 = Schadenspunkte" + System.getProperty("line.separator") +
	      "var phase = " + (this.gegnerbeginnt?0:1) + ";" + System.getProperty("line.separator") +
	      System.getProperty("line.separator") +
	      "function wuerfel(){" + System.getProperty("line.separator") +
	      "   var at = top.AT;" + System.getProperty("line.separator") +
	      "   var pa = top.PA;" + System.getProperty("line.separator") +
	      "   var rs = top.RS;" + System.getProperty("line.separator") +
	      "   var wuerfelTP = top.wuerfelTP;" + System.getProperty("line.separator") +
	      "   var zusatzTP = top.zusatzTP;" + System.getProperty("line.separator") +
	      System.getProperty("line.separator") +
	      "   var t1 = document.createTextNode(String.fromCharCode(160));" + System.getProperty("line.separator") +
	      "   var t2 = document.createTextNode(String.fromCharCode(160));" + System.getProperty("line.separator") +
	      System.getProperty("line.separator") +
	      "   if(phase == 0){" + System.getProperty("line.separator") +
	      "      document.getElementById('w1').replaceChild(document.createTextNode(String.fromCharCode(160)), document.getElementById('w1').firstChild);" + System.getProperty("line.separator") +
	      "      finte = gibFinte();" + System.getProperty("line.separator") +
	      "      wuchtschlag = gibWuchtschlag();" + System.getProperty("line.separator") +
	      "      plus = finte + wuchtschlag + erschwert;" + System.getProperty("line.separator") +
	      "      if(plus == 0)" + System.getProperty("line.separator") +
	      "         document.F.button.value = ' Attacke ';" + System.getProperty("line.separator") +
	      "      else" + System.getProperty("line.separator") +
	      "         document.F.button.value = ' Attacke (+'+plus+')';" + System.getProperty("line.separator") +
	      "      phase = 2;" + System.getProperty("line.separator") +
	      "   }else if(phase == 1){" + System.getProperty("line.separator") +
	      "      var w1 = Math.ceil((Math.random()*100)%20);" + System.getProperty("line.separator") +
	      "      document.getElementById('w1').replaceChild(document.createTextNode(String.fromCharCode(160)), document.getElementById('w1').firstChild);" + System.getProperty("line.separator") +
	      "      if(gegnerAT >= w1){" + System.getProperty("line.separator") +
	      "         t2 = document.createTextNode('Angriff gelungen!');" + System.getProperty("line.separator") +
	      "         if(erschwert == 0)" + System.getProperty("line.separator") +
	      "            document.F.button.value = ' Parade ';" + System.getProperty("line.separator") +
	      "         else" + System.getProperty("line.separator") +
	      "            document.F.button.value = ' Parade (+'+erschwert+')';" + System.getProperty("line.separator") +
	      "         phase = 3;" + System.getProperty("line.separator") +
		  "      }else{" + System.getProperty("line.separator") +
		  "         t2 = document.createTextNode('Angriff misslungen!');" + System.getProperty("line.separator") +
		  "         document.F.button.value = ' Weiter ';" + System.getProperty("line.separator") +
		  "         phase = 0;" + System.getProperty("line.separator") +
		  "      }" + System.getProperty("line.separator") +
		  "   }else if(phase == 2){" + System.getProperty("line.separator") +
		  "      var w1 = Math.ceil((Math.random()*100)%20);" + System.getProperty("line.separator") +
		  "      document.getElementById('w1').replaceChild(document.createTextNode(w1), document.getElementById('w1').firstChild);" + System.getProperty("line.separator") +
	      "      finte = gibFinte();" + System.getProperty("line.separator") +
	      "      wuchtschlag = gibWuchtschlag();" + System.getProperty("line.separator") +
	      "      plus = finte + wuchtschlag + erschwert;" + System.getProperty("line.separator") +
	      "      if(at >= w1 + plus){" + System.getProperty("line.separator") +
	      "         if(plus == 0)" + System.getProperty("line.separator") +
	      "            t1 = document.createTextNode('Angriff gelungen!');" + System.getProperty("line.separator") +
	      "         else" + System.getProperty("line.separator") +
	      "            t1 = document.createTextNode('Angriff (+'+plus+') gelungen!');" + System.getProperty("line.separator") +
	      "         erschwert = 0;" + System.getProperty("line.separator") +
		  "         w1 = Math.ceil((Math.random()*100)%20);" + System.getProperty("line.separator") +
	      "         if(gegnerPA >= w1 + finte){" + System.getProperty("line.separator") +
	      "            if(finte > 0)" + System.getProperty("line.separator") +
	      "               t2 = document.createTextNode('Parade (+'+finte+') gelungen!');" + System.getProperty("line.separator") +
	      "            else" + System.getProperty("line.separator") +
	      "               t2 = document.createTextNode('Parade gelungen!');" + System.getProperty("line.separator") +
		  "            document.F.button.value = ' Weiter ';" + System.getProperty("line.separator") +
		  "            phase = 1;" + System.getProperty("line.separator") +
		  "         }else{" + System.getProperty("line.separator") +
          "            if(finte > 0)" + System.getProperty("line.separator") +
          "               t2 = document.createTextNode('Parade (+'+finte+') misslungen!');" + System.getProperty("line.separator") +
          "            else" + System.getProperty("line.separator") +
          "               t2 = document.createTextNode('Parade misslungen!');" + System.getProperty("line.separator") +
		  "            document.F.button.value = ' Trefferpunkte austeilen ';" + System.getProperty("line.separator") +
		  "            phase = 4;" + System.getProperty("line.separator") +
		  "         }" + System.getProperty("line.separator") +
		  "      }else{" + System.getProperty("line.separator") +
	      "         erschwert = finte + wuchtschlag;" + System.getProperty("line.separator") +        
		  "         t1 = document.createTextNode('Angriff misslungen!');" + System.getProperty("line.separator") +
		  "         document.F.button.value = ' Weiter ';" + System.getProperty("line.separator") +
		  "         phase = 1;" + System.getProperty("line.separator") +
		  "      }" + System.getProperty("line.separator") +
		  "   }else if(phase == 3){" + System.getProperty("line.separator") +
		  "      t2 = document.createTextNode('Angriff gelungen!');" + System.getProperty("line.separator") +
		  "      var w1 = Math.ceil((Math.random()*100)%20);" + System.getProperty("line.separator") +
		  "      document.getElementById('w1').replaceChild(document.createTextNode(w1), document.getElementById('w1').firstChild);" + System.getProperty("line.separator") +
	      "      if(pa >= w1 + erschwert){" + System.getProperty("line.separator") +
	      "         if(erschwert == 0)" + System.getProperty("line.separator") +
	      "            t1 = document.createTextNode('Parade gelungen!');" + System.getProperty("line.separator") +
	      "         else" + System.getProperty("line.separator") +
	      "            t1 = document.createTextNode('Parade (+'+erschwert+') gelungen!');" + System.getProperty("line.separator") +
	      "         erschwert = 0;" + System.getProperty("line.separator") +
		  "         if(gegnerUnbewaffnet == 1){" + System.getProperty("line.separator") +
		  "            document.F.button.value = ' Trefferpunkte austeilen ';" + System.getProperty("line.separator") +
		  "            gegnerUnbewaffnet = 2;" + System.getProperty("line.separator") +
		  "            phase = 4;" + System.getProperty("line.separator") +
		  "         }else{" + System.getProperty("line.separator") +
		  "            document.F.button.value = ' Weiter ';" + System.getProperty("line.separator") +
		  "            phase = 0;" + System.getProperty("line.separator") +
		  "         }" + System.getProperty("line.separator") +
		  "      }else{" + System.getProperty("line.separator") +
	      "         if(erschwert == 0)" + System.getProperty("line.separator") +
	      "            t1 = document.createTextNode('Parade misslungen!');" + System.getProperty("line.separator") +
	      "         else" + System.getProperty("line.separator") +
	      "            t1 = document.createTextNode('Parade (+'+erschwert+') misslungen!');" + System.getProperty("line.separator") +
	      "         erschwert = 0;" + System.getProperty("line.separator") +
		  "         document.F.button.value = ' Schadenspunkte einstecken ';" + System.getProperty("line.separator") +
		  "         phase = 5" + System.getProperty("line.separator") +
		  "      }" + System.getProperty("line.separator") +
		  "   }else if(phase == 4){" + System.getProperty("line.separator") +
		  "      var w1 = Math.ceil((Math.random()*100)%6);" + System.getProperty("line.separator") +
		  "      document.getElementById('w1').replaceChild(document.createTextNode(w1), document.getElementById('w1').firstChild);" + System.getProperty("line.separator") +
		  "      if(wuerfelTP > 1){" + System.getProperty("line.separator") +
		  "         var w2 = Math.ceil((Math.random()*100)%6);" + System.getProperty("line.separator") +
		  "         w1 = w1 + w2;" + System.getProperty("line.separator") +
		  "      }" + System.getProperty("line.separator") +
		  "      var tp = w1 + zusatzTP + wuchtschlag;" + System.getProperty("line.separator") +
	      "      if(gegnerUnbewaffnet == 2){" + System.getProperty("line.separator") +
	      "         tp = Math.floor(tp/2);" + System.getProperty("line.separator") +
	      "      }" + System.getProperty("line.separator") +
		  "      if(tp == 1){" + System.getProperty("line.separator") +
		  "         t2 = document.createTextNode(tp + ' Trefferpunkt!');" + System.getProperty("line.separator") +
		  "      }else{" + System.getProperty("line.separator") +
		  "         t2 = document.createTextNode(tp + ' Trefferpunkte!');" + System.getProperty("line.separator") +
		  "      }" + System.getProperty("line.separator") +
		  "      var sp = tp - gegnerRS;" + System.getProperty("line.separator") +
		  "      if(sp > 0){" + System.getProperty("line.separator") +
		  "         gegnerLE = gegnerLE - sp;" + System.getProperty("line.separator") +
		  "      }" + System.getProperty("line.separator") +
		  "      document.F.button.value = ' Weiter ';" + System.getProperty("line.separator") +
		  System.getProperty("line.separator") +
		  "      if(gegnerLE <= 5){" + System.getProperty("line.separator") +
		  "         document.getElementById('gegner').src = '../Bilder/Gegner8.gif';" + System.getProperty("line.separator") +
		  "      }else if(gegnerLE <= gegnerLEmax / 3.5){" + System.getProperty("line.separator") +
		  "         document.getElementById('gegner').src = '../Bilder/Gegner7.gif';" + System.getProperty("line.separator") +
		  "      }else if(gegnerLE <= gegnerLEmax / 3){" + System.getProperty("line.separator") +
		  "         document.getElementById('gegner').src = '../Bilder/Gegner6.gif';" + System.getProperty("line.separator") +
		  "      }else if(gegnerLE <= gegnerLEmax / 2.5){" + System.getProperty("line.separator") +
		  "         document.getElementById('gegner').src = '../Bilder/Gegner5.gif';" + System.getProperty("line.separator") +
		  "      }else if(gegnerLE <= gegnerLEmax / 2){" + System.getProperty("line.separator") +
		  "         document.getElementById('gegner').src = '../Bilder/Gegner4.gif';" + System.getProperty("line.separator") +
		  "      }else if(gegnerLE <= gegnerLEmax / 1.5){" + System.getProperty("line.separator") +
		  "         document.getElementById('gegner').src = '../Bilder/Gegner3.gif';" + System.getProperty("line.separator") +
		  "      }else if(gegnerLE < gegnerLEmax){" + System.getProperty("line.separator") +
		  "         document.getElementById('gegner').src = '../Bilder/Gegner2.gif';" + System.getProperty("line.separator") +
		  "      }" + System.getProperty("line.separator") +
		  "      if(gegnerLE < gegnerLEmin){" + System.getProperty("line.separator") +
		  "         setzeLink('"+Abenteuer.fuelleDreistellig(this.sieg)+".html', '"+this.textSieg+" ["+this.sieg+"]');" + System.getProperty("line.separator") +
		  "         document.F.button.disabled = true;" + System.getProperty("line.separator") +
		  "      }" + System.getProperty("line.separator") +
	      "      if(gegnerUnbewaffnet == 2){" + System.getProperty("line.separator") +
	      "         gegnerUnbewaffnet = 1;" + System.getProperty("line.separator") +
	      "         phase = 0;" + System.getProperty("line.separator") +
	      "      }else{" + System.getProperty("line.separator") +		      	  
		  "         phase = 1;" + System.getProperty("line.separator") +
		  "      }" + System.getProperty("line.separator") +
		  "   }else if(phase == 5){" + System.getProperty("line.separator") +
		  "      var w1 = Math.ceil((Math.random()*100)%6);" + System.getProperty("line.separator") +
		  "      if(gegnerWuerfelTP > 1){" + System.getProperty("line.separator") +
		  "         var w2 = Math.ceil((Math.random()*100)%6);" + System.getProperty("line.separator") +
		  "         w1 = w1 + w2;" + System.getProperty("line.separator") +
		  "      }" + System.getProperty("line.separator") +
		  "      var tp = w1 + gegnerZusatzTP;" + System.getProperty("line.separator") +
		  "      var sp = tp - rs;" + System.getProperty("line.separator") +
		  "      if(sp < 0){" + System.getProperty("line.separator") +
		  "         sp = 0;" + System.getProperty("line.separator") +
		  "      }" + System.getProperty("line.separator") +
		  "      if(sp >= top.LE){" + System.getProperty("line.separator") +
		  "         sp = top.LE - 1;" + System.getProperty("line.separator") +
		  "      }" + System.getProperty("line.separator") +
		  "      top.LE = top.LE - sp;" + System.getProperty("line.separator") +
		  "      if(sp == 1){" + System.getProperty("line.separator") +
		  "         t1 = document.createTextNode(sp + ' Schadenspunkt!');" + System.getProperty("line.separator") +
		  "      }else{" + System.getProperty("line.separator") +
		  "         t1 = document.createTextNode(sp + ' Schadenspunkte!');" + System.getProperty("line.separator") +
		  "      }" + System.getProperty("line.separator") +
		  "      top.frames[0].frames[0].document.F.LE.value = top.LE;" + System.getProperty("line.separator") +
		  "      document.F.button.value = ' Weiter ';" + System.getProperty("line.separator") +
		  "      if(top.LE <= 5){" + System.getProperty("line.separator") +
		  "         setzeLink('"+Abenteuer.fuelleDreistellig(this.niederlage)+".html', '"+this.textNiederlage+" ["+this.niederlage+"]');" + System.getProperty("line.separator") +
		  "         if(gegnerLE == gegnerLEmax){" + System.getProperty("line.separator") +
		  "            document.getElementById('gegner').src = '../Bilder/Gegner0.gif';" + System.getProperty("line.separator") +
		  "         }" + System.getProperty("line.separator") +
		  "         document.F.button.disabled = true;" + System.getProperty("line.separator") +
		  "      }" + System.getProperty("line.separator") +
		  "      phase = 0;" + System.getProperty("line.separator") +
		  "   }" + System.getProperty("line.separator") +
		  System.getProperty("line.separator") +
		  "   document.getElementById('t1').replaceChild(t1, document.getElementById('t1').firstChild);" + System.getProperty("line.separator") +
		  "   document.getElementById('t2').replaceChild(t2, document.getElementById('t2').firstChild);" + System.getProperty("line.separator") +
		  "}" + System.getProperty("line.separator");

		String setzeLinks = System.getProperty("line.separator") +
          "function setzeLink(ziel, text){" + System.getProperty("line.separator") +
          "   for(var i = document.getElementById('links').childNodes.length; i != 0; i--){" + System.getProperty("line.separator") +
          "      document.getElementById('links').removeChild(document.getElementById('links').firstChild);" + System.getProperty("line.separator") +
          "   }" + System.getProperty("line.separator") +
          "   var link = document.createElement('a');" + System.getProperty("line.separator") +
          "   var href = document.createAttribute('href');" + System.getProperty("line.separator") +
          "   link.setAttributeNode(href);" + System.getProperty("line.separator") +
          "   href.nodeValue = ziel;" + System.getProperty("line.separator") +
          "   link.appendChild(document.createTextNode(text));" + System.getProperty("line.separator") +
          "   document.getElementById('links').appendChild(link);" + System.getProperty("line.separator") +
          "}" + System.getProperty("line.separator");

		String gibFinte = System.getProperty("line.separator") +
		  "function gibFinte(){" + System.getProperty("line.separator") +
		  "   var wert = 0;" + System.getProperty("line.separator") +
		  "   if(document.AT.cbFinte.checked){" + System.getProperty("line.separator") +
		  "      wert = parseInt(document.AT.Finte.value);" + System.getProperty("line.separator") +
		  "   }" + System.getProperty("line.separator") +
		  "   return wert;" + System.getProperty("line.separator") +
		  "}" + System.getProperty("line.separator");

		String setzeFinte = System.getProperty("line.separator") +
		  "function setzeFinte(inkrement){" + System.getProperty("line.separator") +
		  "   var wert = parseInt(document.AT.Finte.value) + inkrement;" + System.getProperty("line.separator") +
		  "   if(wert < 0)" + System.getProperty("line.separator") +
		  "      wert = 0;" + System.getProperty("line.separator") +
		  "   else{" + System.getProperty("line.separator") +
		  "      document.AT.Finte.value = wert;" + System.getProperty("line.separator") +
		  "      if(phase == 2){" + System.getProperty("line.separator") +
		  "         if(document.AT.cbFinte.checked)" + System.getProperty("line.separator") +
		  "            finte = wert;" + System.getProperty("line.separator") +
		  "         else" + System.getProperty("line.separator") +
		  "            finte = 0;" + System.getProperty("line.separator") +
		  "         plus = erschwert + finte + wuchtschlag;" + System.getProperty("line.separator") +
		  "         if(plus != 0)" + System.getProperty("line.separator") +
		  "            document.F.button.value = ' Attacke (+'+plus+')';" + System.getProperty("line.separator") +
		  "         else" + System.getProperty("line.separator") +
		  "            document.F.button.value = ' Attacke ';" + System.getProperty("line.separator") +
		  "      }" + System.getProperty("line.separator") +
		  "   }" + System.getProperty("line.separator") +
		  "}" + System.getProperty("line.separator");

		String gibWuchtschlag = System.getProperty("line.separator") +
		  "function gibWuchtschlag(){" + System.getProperty("line.separator") +
		  "   var wert = 0;" + System.getProperty("line.separator") +
		  "   if(document.AT.cbWuchtschlag.checked){" + System.getProperty("line.separator") +
		  "      wert = parseInt(document.AT.Wuchtschlag.value);" + System.getProperty("line.separator") +
		  "   }" + System.getProperty("line.separator") +
		  "   return wert;" + System.getProperty("line.separator") +
		  "}" + System.getProperty("line.separator");

		String setzeWuchtschlag = System.getProperty("line.separator") +
		  "function setzeWuchtschlag(inkrement){" + System.getProperty("line.separator") +
		  "   var wert = parseInt(document.AT.Wuchtschlag.value) + inkrement;" + System.getProperty("line.separator") +
		  "   if(wert < 0)" + System.getProperty("line.separator") +
		  "      wert = 0;" + System.getProperty("line.separator") +
		  "   else{" + System.getProperty("line.separator") +
		  "      document.AT.Wuchtschlag.value = wert;" + System.getProperty("line.separator") +
		  "      if(phase == 2){" + System.getProperty("line.separator") +
		  "         if(document.AT.cbWuchtschlag.checked)" + System.getProperty("line.separator") +
		  "            wuchtschlag = wert;" + System.getProperty("line.separator") +
		  "         else" + System.getProperty("line.separator") +
		  "            wuchtschlag = 0;" + System.getProperty("line.separator") +
		  "         plus = erschwert + finte + wuchtschlag;" + System.getProperty("line.separator") +
		  "         if(plus != 0)" + System.getProperty("line.separator") +
		  "            document.F.button.value = ' Attacke (+'+plus+')';" + System.getProperty("line.separator") +
		  "         else" + System.getProperty("line.separator") +
		  "            document.F.button.value = ' Attacke ';" + System.getProperty("line.separator") +
		  "      }" + System.getProperty("line.separator") +
	      "   }" + System.getProperty("line.separator") +
		  "}" + System.getProperty("line.separator");
		
		return kampf + wuerfel + setzeLinks + gibFinte + setzeFinte + gibWuchtschlag + setzeWuchtschlag;
	}
}
